
title;
footnote;

* same methodology, use the CLINICAL data and set risk values
* set at-risk values for chol, sbp, dbp, hr
* use PICTURE formats to mark at-risk values;

libname x 'd:\epi697\datasets';

proc print data=x.clinical (obs=25);
format _all_;
run;

* 
an easy way to add a sequential number 
to each observation within a by-group
the 'unofficial' name for this technique is a DOW
or the 'do loop of Whitlock' ... after Ian Whitlock (aka SAS Yoda)
;

data risk;
array risk(4) _temporary_ (350 150 100 80);
array x(4) chol sbp dbp hrate;
* the DOW;
do nv=1 by 1 until (last.id);
   set x.clinical;
   by id;
   nrisk = 0;
   do j = 1 to 4;
      nrisk + (x(j) ge risk(j));
   end;
   output;
end;

format _all_;
label
nv    = '###'
visit = 'DATE OF VISIT'
nrisk = 'RISK FACTORS'
chol  = 'CHOLESTEROL'
sbp   = 'SYSTOLIC BP'
dbp   = 'DIASTOLIC BP'
hrate = 'HEART RATE'
;
run;

* for EXCEL import ... this uses the default style;

* 
choose colors for 'traffic lighting'
the values are expressed as RGB (red/green/blue)
a great web site for finding these numbers and colors
http://www.colorbrewer.org
RISK is RED, OTHER is WHITE 
;
proc format;
* background;
value chol_  350 - high = 'cxfb6a4a'     other = 'cxffffff';
value sbp_   150 - high = 'cxfb6a4a'     other = 'cxffffff';
value dbp_   100 - high = 'cxfb6a4a'     other = 'cxffffff';
value hrate_ 80  - high = 'cxfb6a4a'     other = 'cxffffff';
run;

options missing=' ';
ods listing close;
ods results off;
ods html file='z:\scores_xls.html';

title;

proc print data=risk noobs label;
var nv visit nrisk;
var chol  / style={background=chol_.};
var sbp   / style={background=sbp_.};
var dbp   / style={background=dbp_.};
var hrate / style={background=hrate_.};
by id;
format visit mmddyy10.;
run;

ods html close;
ods listing;
ods results on;
options missing='.';

* for web posting ... this uses a STYLE ... BARRETTSBLUE;

* 
choose colors for 'traffic lighting'
background:  RISK is RED, OTHER is GRAY
foreground:  RISK is WHITE, OTHER is BLACK

;
proc format;
* background;
value chol_  350 - high = 'cxff0000'     other = 'cxe7e3e7';
value sbp_   150 - high = 'cxff0000'     other = 'cxe7e3e7';
value dbp_   100 - high = 'cxff0000'     other = 'cxe7e3e7';
value hrate_ 80  - high = 'cxff0000'     other = 'cxe7e3e7';
* foreground;
value _chol  350 - high = 'cxffffff'     other = 'cx000000';
value _sbp   150 - high = 'cxffffff'     other = 'cx000000';
value _dbp   100 - high = 'cxffffff'     other = 'cx000000';
value _hrate 80  - high = 'cxffffff'     other = 'cx000000';
run;

options missing=' ';
ods listing close;
ods results off;
ods html file='z:\scores_web.html' style=barrettsblue;

title;
proc print data=risk noobs label;
var nv visit nrisk;
var chol  / style=[background=chol_.  foreground=_chol.];
var sbp   / style=[background=sbp_.   foreground=_sbp.];
var dbp   / style=[background=dbp_.   foreground=_dbp.];
var hrate / style=[background=hrate_. foreground=_hrate.];
by id;
format visit mmddyy10.;
run;

ods html close;
ods listing;
ods results on;
options missing='.';

* what styles are avaialble;
proc template;
list styles;
run;

* look at the 'rules' for a given style;
proc template;
source styles.default;
run;
